const _ = require('lodash')

const util = {
  dependsOn(res, prefix, ids, cacheHints) {
    if (res /*&& prefix*/ && ids) {
      if (!res.dependsOn) res.dependsOn = {}
      res.dependsOn[prefix?prefix:''] = _.union(res.dependsOn[prefix?prefix:''],ids)

      let dependsOnList = []
      for (let type in res.dependsOn) {
        if (type) {
          dependsOnList = dependsOnList.concat(res.dependsOn[type].map( id => `${type}:${id}` ))
        } else {
          dependsOnList = dependsOnList.concat(res.dependsOn[type])
        }
      }
      const dependsOn = dependsOnList.join(' ')
      if (dependsOn/* && dependsOn.length < (6*1024) */ ) res.setHeader('X-Depends-On',dependsOn)
      if (cacheHints && cacheHints.volatileContent) res.setHeader('X-Volatile-Content',cacheHints.volatileContent)
    }
  },

  duration(hrTimer) {
    if (hrTimer) {
      const diff = process.hrtime(hrTimer)
      return Math.round((diff[0] * 1e9 + diff[1]) / 1000000)
    } else {
      return process.hrtime()
    }
  }
}

module.exports = util

